
VisIt - Bug # 1330: VisIt doesn't launch when it is linked to with a symbolic link.
OS: All
Subject: VisIt doesn't launch when it is linked to with a symbolic link.

Description: Here is the e-mail describing the failure.



Hello



The latest version of visit doesn't work when started with any type of a symlink with the following setup:



which visit

/home/ilja/bin/visit



file /home/ilja/bin/visit

/home/ilja/bin/visit: symbolic link to

`/home/ilja/Tiedostot/Ohjelmat/visit/bin/visit'



file /home/ilja/Tiedostot/Ohjelmat/visit/bin/visit

/home/ilja/Tiedostot/Ohjelmat/visit/bin/visit: symbolic link to `frontendlauncher'



Here's what frontendlauncher from 2.6.1 prints when I insert print progdir, visitdir at the end of # 

----------------------------------------------

#                            Figure out visitdir

# ----------------------------------------------



/home/ilja/bin /home/ilja/

There is no current version of VisIt.



2.6.0 behaves as reported previously.



Ilja

History

02/08/2013 02:28 pm - Cyrus Harrison

#1318 may have resolved this issue.

02/19/2013 04:15 pm - Eric Brugger

- Status changed from New to Pending

- Assigned to set to Eric Brugger

- Target version set to 2.6.2

Here is another e-mail (2/5/2013 11:35PM), which includes a fix.



> We thought we had that fixed for 2.6.1. I will enter a new ticket and 

> target the 2.6.2 release.

> Thanks for reporting the error.

02/23/2013 1/2





The following makes it work for me:



ilja@Vaio:~/visit/bin$ diff -u frontendlauncher.old frontendlauncher

--- frontendlauncher.old	2013-02-06 09:28:31.000000000 +0200

+++ frontendlauncher	2013-02-06 09:34:14.000000000 +0200

@@ -111,29 +111,11 @@

  if progdir == "":

      progdir = "."



-# Check if we are called via a symbolic link to visit

-try:

-    link = os.readlink(sys.argv[0])

-    linkdir, linkname = os.path.split(link)

-    if linkname == "visit":

-        if linkdir == "":

-            linkdir = "."

-        progdir += (os.path.sep, linkdir)

-except:

-    # We'll get here if sys.argv[0] was not a link. That can happen in

-    # out of source builds.

-    pass

-

-cwd = os.path.abspath(os.path.curdir)

-if progdir[0] == '/':

-    tmpdir = progdir

-elif progdir == '.':

-    tmpdir = cwd

-else:

-    tmpdir = cwd + os.path.sep + progdir

-visitdir, tmp = os.path.split(os.path.abspath(tmpdir))

-if visitdir[-1] != os.path.sep:

-    visitdir = visitdir + os.path.sep

+frontendpath = os.path.realpath(sys.argv[0]) # visitdir is two 

+directories up from frontendlauncher visitdir \

+	= os.path.split(os.path.split(frontendpath)[0])[0] \

+	+ os.path.sep



Ilja
